import { ComponentDoc, Documentation } from './Documentation';
import { DocGenOptions, ParseOptions } from './parse';
export { TemplateParserOptions } from './parse-template';
export { ScriptHandler, TemplateHandler } from './parse';
export { ComponentDoc, DocGenOptions, ParseOptions, Documentation };
/**
 * Parse the components at filePath and return props, public methods, events and slots
 * @param filePath absolute path of the parsed file
 * @param opts
 */
export declare function parse(filePath: string, opts?: DocGenOptions | {
    [alias: string]: string;
}): ComponentDoc;
/**
 * Parse the `source` assuming that it is located at `filePath` and return props, public methods, events and slots
 * @param filePath absolute path of the parsed file
 * @param opts
 */
export declare function parseSource(source: string, filePath: string, opts?: DocGenOptions | {
    [alias: string]: string;
}): ComponentDoc;
